function [ZZstra,SSstra] = ANALYTIC(diameter,dgamdz,Rho0,u0,GG,DepthDif)
%************ calculate dilution supposing the linear density profile 
%************ from the height of diffusser to the max achieved height
% const
      konst1 = 3.98;
      konst2 = 0.071;
      konst3 = 0.089;
   delRho0 = Rho0 - 1000.0;
   QQ = pi*u0*(diameter)^2/4.0;
   %Fischer et al. 1979, p.345 Rho0=rho fresh water}
   %Lee H.W. and Neville-Jones, 1987, J.Hydr.Eng.,113, 5, p. 616 Rho0=rho_a=rho sea-water}
   gprime = GG*delRho0/Rho0;
   fprintf(1,'delRho0: %5.2f  Rho0: %7.2f gprime: %7.4f',delRho0,Rho0,gprime);
   if abs(dgamdz) > 1e-10 % then
      epsprime = -dgamdz/Rho0;
      % Fischer et al., 1979, page 345 }
      N2 =  GG*epsprime;
      fprintf(1,'N2: %10.6f',N2);        
      ZZstra = konst1*exp(0.25*log(gprime*QQ))...
      /exp(3.0*log(N2)/8.0);
      SSstra = konst2*exp((log(gprime) + ...
      5.*log(ZZstra) - 2.*log(QQ))/3.0);
   else
     ZZstra = DepthDif;
     SSstra = konst3*exp((log(gprime) + ...
     5.*log(ZZstra) - 2.*log(QQ))/3.0);
   end

end% function ANALYTIC }
