function dydx = DERIVS(~,y,GG,Rho0,dgamdz,Alpha,Lambda) % ~ stands for 'x', or 's' - 
%*** the independent argument, zthe length of trajectory, which is not present in dydx }
   % y[1] = velocity along the jet axis }
   % y[2] = half-width of a buoyant jet }
   % y[3] = angle of jet axis with respect to XX }
   % y[4] = delta_rho = rho_ambient - rho_jet }
   dydx(1) = 2.0*GG*(Lambda)^2*y(4)*sin(y(3))...
             /(y(1)*Rho0) - 2.0*y(1)*Alpha/y(2);
   dydx(2) = 2.0*Alpha-(y(2)*GG*(Lambda)^2*y(4)*sin(y(3))...
             /((y(1)^2)*Rho0));
   dydx(3) = 2.0*GG*(Lambda)^2*y(4)*cos(y(3))...
             /((y(1)^2)*Rho0);
   dydx(4) = (1.0+(Lambda)^2)*sin(y(3))*dgamdz...
             /((Lambda)^2) - 2.0*Alpha*y(4)/y(2);
end