   function [nok,nbad,kount,xp,yp,xxp,zzp,RiArr,AlphArr] = FAECALI(ystart,...
                  NV,kmax,...
                  HeightArr,GamArr,...
                  varyAlpha,DepthDif,...
                  x1,x2,s1,smin,bmax,dxsav,...
                  Lambda,Diameter,Height0,theta0,YesMakima)
%**************************************************}
   Zmax = DepthDif;
   GG = 9.806; % for the TS Gulf }
   EPS = smin; % accuracy }
   EPS_U = 1.0e-5;
   Alphj = 0.0535; % Fischer et al., 1979, page 371: }
   Alphp = 0.0833;
   Rip = 0.557;
   maxstp=10000;
   NN = 500;
   two=2.0;
   zero=0.0;
   tiny=1.0e-30;
   xp = zeros(NN,1); xxp = xp; zzp = xp; RiArr = xp; AlphArr = xp;
   yp = zeros(NN,NV);
   x = x1;
   xxp(1) = 6.2*Diameter*cos(theta0);% starting distance }
   zzp(1) = Height0+6.2*Diameter*sin(theta0);
   if (x2 > x1) % then 
      ds = abs(s1);
   else
       ds = -abs(s1);
   end
   nok = 0;
   nbad = 0;
   kount = 1;%1 0;
   y = ystart;
   yscal = zeros(1:NV);
   xp(1) = x1; % inserted on 15 September 98 } Nov 2019: x1 = SS0 = 3.72
   xsav = x-dxsav*two; % dxsv = 0.1
   yold = ystart;% 14 Nov 2019: to define the 'previous values' of solution 
   yp(1,:) = ystart;

   
   if YesMakima == 'Y'
      ppppspl = makima(HeightArr,GamArr');
      % https://blogs.mathworks.com/cleve/2019/04/29/makima-piecewise-cubic-interpolation/
   else
      ppppspl = spline(HeightArr,[0 GamArr' 0]); 
      % [0 GamArr' 0] added zero first derivatives in the first and the last data point
   end   
   
% (******     START BIG for LOOP:    ****************)
for nstp = 1 : maxstp % do % begin
   [gama, dgamdz]=ppvalder(ppppspl,zzp(kount));
   fprintf(1,'Start loop, nstp= %3d; kount= %3d; xp(%3d)= %6.4f; xxp(%3d)= %6.4f; zzp(%3d)= %6.4f; gama= %6.2f ; dgamdz= %10.4f\n',...
           nstp,kount,kount,xp(kount),kount,xxp(kount),kount,zzp(kount),gama,dgamdz);
   Rho = gama + 1000;
   [Ri, Alpha] = MakeRiAlpha(y,Alphj,Alphp,Lambda,Rip,Rho,GG,varyAlpha);
   fprintf(1,'x= %7.4f Ri= %6.2f ; Alpha= %6.2f\n',x,Ri,Alpha);
   fprintf(1,'y(1)= %10.5f ; y(2)= %10.5f ; y(3)= %10.5f ; y(4)= %10.5f\n',...
            y(1),y(2),y(3),y(4));
   dydx = DERIVS(x,y,GG,Rho,dgamdz,Alpha,Lambda);
   fprintf(1,'dydx(1)= %10.5f ; dydx(2)= %10.5f ; dydx(3)= %10.5f ; dydx(4)= %10.5f\n',...
           dydx(1),dydx(2),dydx(3),dydx(4));
   fprintf(1,'kount=%4d x=%7.4f xsav=%7.4f dxsav=%5.4f zzp(%4d)=%7.4f; Zmax=%6.2f\n\n',...
                kount,x,xsav,dxsav, kount,zzp(kount),Zmax);
   for i = 1 : NV% var % do % begin
  % Scaling for monitoring accuracy - modify if necessary }
         yscal(i) = abs(y(i))+abs(dydx(i)*ds)+tiny;
   end
   xsav = x;
   yold = y; 
   [x,y, dsdid, dsnext] = RKQC(yold,dydx,NV,xsav,ds,EPS,yscal,...
                               GG,Rho,dgamdz,Alpha,Lambda);% added ystart      
   ds = dsnext;                        
   %% nok = number of good steps, }
   %% nbad = number of bad (repaired) steps }
   %% kount = number of stored (written) values }
   if (dsdid - ds <= tiny) % then % begin
         nok = nok+1;
   else % begin
         nbad = nbad+1;
   end
   if ( (abs(x-xp(kount)) > abs(dxsav)) && (kount < kmax-1) && ...
         (((x-x2)*(x2-x1)) < zero)   && ...% x<x2=SSmax and x2=SSmax > x1=SS0
         ((y(2) <= bmax ) && (zzp(kount) > 0)) && ...
         ((y(3) >= 0) && (zzp(kount) > 0)) && ...
          (zzp(kount) < Zmax) )
         kount = kount+1;
         xp(kount) = x;
         for i = 1 : NV% var % do % begin
            yp(kount,i) = y(i); %
         end
         if kount > 1 % then % begin
            xxp(kount) = xxp(kount-1) + ...
               (xp(kount)-xp(kount-1))*cos(y(3));
            zzp(kount) = zzp(kount-1) + ...
               (xp(kount)-xp(kount-1))*sin(y(3));
         else % kount = 1
            xxp(kount) = (xp(kount))*cos(y(3));
            zzp(kount) = (xp(kount))*sin(y(3));
         end    
            RiArr(kount) = Ri;
            AlphArr(kount) = Alpha;
   end % if (abs(x-xsav) > abs(dxsav)) }
   % if stepsize can overshoot, decrease it }
   if (((x+ds-x2)*(x+ds-x1)) > zero) % then x+ds > x2 and x+ds>x1; x2 = SSmax = 100
      ds = x2-x;
   end     
   % Are we done?: if (((x-x2)*(x2-x1)) >= zero) THEN % begin
   % finish when y[1] = u < 0, NOT when theta (y[3]) < 0, 
   % as supposed in Water Quality Modelling (p. 162) }
   maxzzp = max(zzp(1:kount));
   if ( (((x-x2)*(x2-x1)) >= zero) || ...% x>x2=SSmax and x2=SSmax > x1=SS0 
      ((y(3) < 0.0) && (zzp(kount) > 0)) || ...
      ((y(1) < EPS_U) && (zzp(kount) > 0)) || ...
      ((y(2) > bmax ) && (zzp(kount) > 0)) || ...
      ((zzp(kount) < maxzzp) || (zzp(kount) >= Zmax)) ) 
         fprintf(1,'Closing LONG IF zzp(%4d)=%7.4f; Zmax=%6.2f\n',kount,zzp(kount),Zmax);
         fprintf(1,'Before the RETURN (=EXIT from Faecali) command;  kount= %6d ',kount); 
         prompt = 'Press Return\n\n'; str = input(prompt,'s');
         kount = kount+1;
         xp(kount) = x;
         for i = 1 : NV% var % do % begin
            yp(kount,i) = y(i); % 
         end
         if kount > 1 % then % begin
            xxp(kount) = xxp(kount-1) + ...
               (xp(kount)-xp(kount-1))*cos(y(3));
            zzp(kount) = zzp(kount-1) + ...
               (xp(kount)-xp(kount-1))*sin(y(3));
         else % kount = 1
            xxp(kount) = (xp(kount))*cos(y(3));
            zzp(kount) = (xp(kount))*sin(y(3));
         end    
            RiArr(kount) = Ri;
            AlphArr(kount) = Alpha;         
         return; % !!!! in Fortran (and Pascal) GOTO 99 % normal exit from function}
   end % if (()) >= 0 OR ... OR ... }
   if (abs(dsnext) < smin) % then % begin
         prompt = 'Pause in routine FAECALI, stepsize too small. Press Return!';
         str = input(prompt,'s');
         return; % exit when the step is too small
   end
end % for nstp }
% (***********   end BIG for LOOP *******************)
end % FAECALI } 
