function [Ri, Alpha] = MakeRiAlpha(y, Alphj, Alphp, Lambda, Rip, Rho0, GG, varyAlpha)
%**************************************************}
  SqrRi = 4.0*(Lambda)^2*(2.0*pi)^0.5*GG*y(2)*y(4)/...
          (Rho0*(1.0+(Lambda)^2)*(y(1))^2);
  if (y(2)*y(4) > 0) % then
    Ri = (SqrRi)^0.5;
  else
    Ri = -(-SqrRi)^0.5;
  end  
  % if UpCase(% varyAlpha) = 'Y' % then
  if varyAlpha == 'Y' % added: = 'Y'
    if SqrRi < -200.0 % then
      Alpha= 0.0;
    else
      Alpha= Alphj*exp(log(Alphp/Alphj)*SqrRi/(Rip)^2); 
      % Fischer et al., 1979, Mixing in Inland Waters and Coastal Waters, 
      % Academic Press, page 371, expression (9.144) in a Chapter 9,
      % 'Turbulent jets and plumes'
    end  
  else
    Alpha = Alphp; % Alpha does not vary, does not depend on Ri (Richardson) number
  end  
end % MakeRiAlpha }
