function [Sm,SSstra,ZZstra,minkount] = STRATIMIDSURF(xp,yp,time,xxp,zzp,NV,kount,...
                              Rho0,Height0,DepthDif,RiArr,AlphArr,Lambda,Diameter,U0,...
                              HeightArr,GamArr,fiddrw,fidkey,fidcom, YesMakima)
%*********************************************************************************************}
   % prompt = 'INSIDE STRATIMIDSURF. Press Return!\n'; str = input(prompt,'s');
   disp('START STRATIMIDSURF');
   GG = 9.81;
   fprintf(fidkey,'%s\r\n','  zzp   Sm    y(1)    y(2)   y(3)  y(4)');  
   for jj = 1 : NV % do
      fprintf(1,'jj=%3d; yp(%3d,%3d)= %6.3f\n',jj,kount,jj,yp(kount,jj));
   end 
   del_dens=diff(yp(:,4)); % look for differences of densities to find the first with del_dens = 0
   % because you need different densities to apply the spline function - which later you did not apply!
   minkount = find(del_dens >= 0.0,1,'first');
   fprintf(1,'In STRATIMIDDLE; minkount=%4d\n',minkount);  
   if zzp(kount) < DepthDif % then % begin 
      prompt = 'REMAINED BELOW. Oki-Doki. Press Return!\n'; str = input(prompt,'s');
   else % tempklo >= kount % begin       
      disp('GONE TO THE SURFACE, Bye-bye.');
      fprintf(1,'kount=%4d; xp(kount)=%8.4f',kount,xp(kount));
 %%%   time  xp    yp1     yp2   yp3     yp4    xxp    zzp   xxp+r   zzp-r xxp-r zzp+r Sm    Ri    Alfa    
      size(yp)
      for jj = 1 : NV % do
          fprintf(1,'jj=%3d; yp(%3d,%3d)= %6.3f\n',jj,kount,jj,yp(kount,jj));
      end   
      fprintf(1,'kount=%4d; xxp(kount)= %5.2f; zzp(kount)= %5.2f; DepthDif= %5.2f\n',...
                  kount,xxp(kount), zzp(kount), DepthDif);
      prompt = 'before end if tempklo < kount; tempklo <= kount! Press Return!\n'; str = input(prompt,'s');
     
   end % if zzp(kount) < DepthDif  else ...
   %****************************************************************************************************}
   fprintf(fiddrw,'%s\r\n','time(s) xp(m)  yp1     yp2     yp3    yp4     xxp   zzp  xxpb  zzpb  xxpt  zzpt   Sm     Ri   Alpha');
   for i = 1 : kount % do % begin
      fprintf(fiddrw,' %5.2f %5.2f',time(i),xp(i));
      for jj = 1 : NV % do      % begin
          fprintf(fiddrw,' %6.3f ',yp(i,jj));
      end
      fprintf(1,'xxp(%3d)%5.2f zzp(%3d)=%5.2f\n',i,xxp(i),i,zzp(i));
      % Sm - numerical dilution along the trajectory }
      Sm = yp(i,1)*(yp(i,2)^2)*4.0*(Lambda)^2/...
           (U0*(Diameter)^2*(1.0+(Lambda)^2));
      fprintf(fiddrw,'%5.2f %5.2f %5.2f %5.2f %5.2f %5.2f %5.2f %6.3f %6.4f\r\n',...
              xxp(i),zzp(i),xxp(i)+yp(i,2)*sin(yp(i,3)),zzp(i)-yp(i,2)*cos(yp(i,3)),...
              xxp(i)-yp(i,2)*sin(yp(i,3)), zzp(i)+yp(i,2)*cos(yp(i,3)),...
              Sm,RiArr(i),AlphArr(i));
   end %i = 1:kount
   
   Sm = yp(1,1)*(yp(1,2))^2*4.0*(Lambda)^2/...
        (U0*(Diameter)^2*(1.0+(Lambda)^2)); % Sm = initial dilution here
   fprintf(fidkey,'%5.2f %5.2f %6.4f %6.4f  %6.4f %6.4f\r\n',...
           zzp(1),Sm,yp(1,1),yp(1,2),yp(1,3),yp(1,4));
   fprintf(fidcom,'1   zzp( 1 )[m]=%7.2f; Sm=%7.2f; yp( 1 ,1)[m/s]=%7.2f yp( 1 ,4)[m]=%7.2f\r\n',...
           zzp(1),Sm,yp(1,1),yp(1,4));   
   fprintf(1,'pred Sm, kount= %4d; zzp=%5.2f yp1=%5.2f; yp2=%6.4f; yp3=%6.4f; yp4=%6.4f\r\n',...
           kount,zzp(kount),yp(kount,1),yp(kount,2),yp(kount,3),yp(kount,4));       
   Sm = yp(kount,1)*(yp(kount,2))^2*4.0*(Lambda)^2/...
        (U0*(Diameter)^2*(1.0+(Lambda)^2)); % Sm = final dilution here
   fprintf(fidkey,'%5.2f %5.2f  %6.4f %6.4f %6.4f %6.4f\r\n',...
           zzp(kount),Sm,yp(kount,1),yp(kount,2),yp(kount,3),yp(kount,4));
   fprintf(fidcom,'%3d zzp(%3d)[m]=%7.2f; Sm=%7.2f; yp(%3d,1)[m/s]=%7.2f yp(%3d,4)[m]=%7.2f\r\n',...
           kount,kount,zzp(kount),Sm,kount,yp(kount,2),kount,yp(kount,4));
   
   %** <dgamdz> from diffusser to max plume height }
   gam0 = Rho0 - 1000;
   if YesMakima == 'Y'
      ppmakima = makima(HeightArr,GamArr);
      gama = ppval(ppmakima,DepthDif); 
   else
      ppsplin = spline(HeightArr,[0 GamArr' 0]);
      % [0 GamArr 0] added zero first derivatives in the first and the last data point     
      gama = ppval(ppsplin,DepthDif);
   end   

   % gama =ppval(ppmakima,DepthDif);
   dgamdz = (gama-gam0)/(DepthDif-Height0);                   
   fprintf(1,'<dgamdz>= %6.2f\r\n', dgamdz);
   %** call analytical estimation of ZZstra **** and SSstra - fixed dgamdz **}
   [ZZstra,SSstra] = ANALYTIC(Diameter,dgamdz,Rho0,U0,GG,DepthDif);
   fprintf(1,'ZZStra=%7.3f; maxzzp=%7.3f; SSstra= %5.2f; Sm= %5.2f\r\n',... 
              ZZstra,zzp(kount),SSstra,Sm);
   fprintf(fidcom,'ZZStra=%7.3f; maxzzp=%7.3f; SSstra= %5.2f; Sm= %5.2f\r\n',... 
              ZZstra,zzp(kount),SSstra,Sm);
end % STRATIMIDSURF }
